﻿Type=StaticCode
Version=2.52
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
'	Type PointType ( _
'		x As Int, _
'		y As Int)
	Dim MaxDistance As Int      : MaxDistance = 6400 '80^2
	Dim MaxPoints As Int        : MaxPoints   = 15
	Dim MaxCurvePoints As Int   : MaxCurvePoints = MaxPoints * 50

	Dim PathPointIndex As Int 
	Dim PathPoints(MaxPoints) As PointType 

	Dim CurvedPath(MaxCurvePoints) As PointType 
	Dim CurvedPathPoints As Int : CurvedPathPoints = 0
	Dim PathComplete As Boolean : PathComplete = False

End Sub

Sub CurveThePath
	'Catmull Rom Splines
	Dim p0, p1, p2, p3, p4 As PointType 
	Dim m0, m1, m2, m3, m4, m5 As PointType 
	Dim t, a, b, c As Double 
	Dim h00, h10, h01, h11 As Double 
	Dim px, py As Int
	Dim i As Int
	
	p0= PathPoints(0)
    p1= PathPoints(1)
    p2= PathPoints(2)
    p3= PathPoints(3)
	p4= PathPoints(4)
	
    m0= Tangent(PathPoints(1), PathPoints(0))
    m1= Tangent(PathPoints(2), PathPoints(0))
	m2= Tangent(PathPoints(2), PathPoints(1))
    m3= Tangent(PathPoints(3), PathPoints(2))
    m4= Tangent(PathPoints(4), PathPoints(2))
	m5= Tangent(PathPoints(4), PathPoints(3))

	For t = 0 To 1 Step 0.02
		a = t*t
		b = 1-t
		c = 2*t
		h00 =  (1 + c) * (b) * (b)
        h10 =  t  * (b) * (b)
        h01 =  a * (3 - c)
        h11 =  a * (t - 1)
         
        px = h00 * p0.x + h10 * m0.x + h01 * p1.x + h11 * m1.x
        py = h00 * p0.y + h10 * m0.y + h01 * p1.y + h11 * m1.y
        'Canvas.setPixel(px, py, 0xFFFFFF);
		SetPoint(CurvedPath(t*50),px,py)
         
        px = h00 * p1.x + h10 * m2.x + h01 * p2.x + h11 * m3.x
        py = h00 * p1.y + h10 * m2.y + h01 * p2.y + h11 * m3.y
        'Canvas.setPixel(px, py, 0xFFFFFF);
		SetPoint(CurvedPath(50+(t*50)),px,py)
         
        px = h00 * p2.x + h10 * m3.x + h01 * p3.x + h11 * m5.x
        py = h00 * p2.y + h10 * m3.y + h01 * p3.y + h11 * m5.y
        'Canvas.setPixel(px, py, 0xFFFFFF);
		SetPoint(CurvedPath(100+(t*50)),px,py)
		
        px = h00 * p3.x + h10 * m4.x + h01 * p4.x + h11 * m5.x
        py = h00 * p3.y + h10 * m4.y + h01 * p4.y + h11 * m5.y
        'Canvas.setPixel(px, py, 0xFFFFFF);
		SetPoint(CurvedPath(150+(t*50)),px,py)

	Next
	PathComplete = True
End Sub

Sub AddtoPath(P As PointType, LastPoint As Boolean) As Boolean 
	Dim Distance As Double
	' Find distance from previous point
	' Add point if distance is last enough or if it is last point
	
	If (LastPoint = True AND PathPointIndex < MaxPoints-2) Then
		PathPointIndex = PathPointIndex + 1
		SetPoint(PathPoints(PathPointIndex),P.x,P.y)
		CurveThePath2
		Return True
	Else If (PathPointIndex = MaxPoints-3) Then
		PathPointIndex = PathPointIndex + 1
		SetPoint(PathPoints(PathPointIndex),P.x,P.y)
		CurveThePath2
	Else If (PathPointIndex < MaxPoints-1) Then
		' Find distance
		Distance = MagnitudeSquared(PathPoints(PathPointIndex),P)
		If Distance > MaxDistance Then ' 25^2
			PathPointIndex = PathPointIndex + 1
			SetPoint(PathPoints(PathPointIndex),P.x,P.y)
			Return True
		End If
	End If
	Return False

End Sub

Sub StartPath(P As PointType)
	Dim i As Int 
	For i = 0 To MaxPoints-1
		SetPoint(PathPoints(i),0,0)
	Next
	Dim PathPoints(MaxPoints) As PointType 
	PathComplete = False
	SetPoint(PathPoints(0),P.x,P.y)
	PathPointIndex = 0			
	Log ("Started Path from: " & PathPoints(0).x & "," & PathPoints(0).y)
End Sub

Sub SetPoint(P As PointType,x1 As Int,y1 As Int)
	P.x = x1
	P.y = y1
End Sub

Sub MagnitudeSquared(P1 As PointType,P2 As PointType) As Double 
	'Log("X1:" & p1.x & " X2:" & p2.x)
	Return ((P1.x - P2.x)*(P1.x - P2.x)) + ((P1.y - P2.y)*(P1.y - P2.y))
End Sub

Sub Tangent(P1 As PointType,P2 As PointType) As PointType 
	Dim P3 As PointType 
	SetPoint(P3, (P1.x-P2.x)/2, (P1.y - P2.y)/2)
    Return P3
End Sub

Sub CurveThePath2
'THE ORIGINAL FUNCTION
'Given 4 points on the spline P0 , P1 , P2 AND P3 , q(t) gives you a point on
'the Bit of the curve between P1 AND P2. q(0) Is always equal To P1 AND q(1)
'Is always equal To P2. It Is Not necessarily True that q(0.5) Is halfway 
'along the length of the curve, by distance.
'q(t) = 0.5 *(
'   			(2 * P1) +
'  				(-P0 + P2) * t +
'				(2*P0 - 5*P1 + 4*P2 - P3) * t^2 +
'				(-P0 + 3*P1- 3*P2 + P3) * t^3	)
			
	Dim p0, p1, p2, p3 As PointType
	Dim ControlPointCount  As Int
	Dim pr As PointType 
	Dim t As Double 
	
	
	'Check there are enough points to draw a spline
	If PathPointIndex = 1 Then 
		PathPoints(3) = PathPoints(1)
		PathPoints(2) = PathPoints(1)
		PathPoints(1) = PathPoints(0)
		PathPoints(0) = PathPoints(0)
		PathPointIndex = 3
	Else If (PathPointIndex = 2) Then
		' Generate two emtpy points (at start and end)
		PathPoints(4) = PathPoints(2)
		PathPoints(3) = PathPoints(2)
		PathPoints(2) = PathPoints(1)
		PathPoints(1) = PathPoints(0)
		PathPoints(0) = PathPoints(0)
		PathPointIndex = 4
		
	Else If (PathPointIndex = 3) Then
		' Generate 1 dummy point at end
		PathPoints(5) = PathPoints(3)
		PathPoints(4) = PathPoints(3)
		PathPoints(3) = PathPoints(2)
		PathPoints(2) = PathPoints(1)
		PathPoints(1) = PathPoints(0)
		PathPoints(0) = PathPoints(0)
		PathPointIndex = 5
		
	Else
		For i = PathPointIndex+1 To 1 Step -1
			PathPoints(i) = PathPoints(i-1)
		Next
		PathPoints(0) = PathPoints(1)
		PathPointIndex = PathPointIndex + 1
	End If
	

		'Get the first three  TLinks in the list of points. This algorithm is going to work by 
		'working out the first three points, then getting the last point at the start of the
		'while loop. After the curve section has been drawn, every point is moved along one,
		'and the TLink is moved to the next one so we can see if it's null, and then get the next
		'p3 from it if not.

	
	ControlPointCount = 0

	Do While (ControlPointCount+3 < PathPointIndex+1)
		p0 = PathPoints(ControlPointCount + 0)
		p1 = PathPoints(ControlPointCount + 1)
		p2 = PathPoints(ControlPointCount + 2)
		p3 = PathPoints(ControlPointCount + 3)
		
		For t=0 To 1 Step .02 
			pr.x  = .5 * ( (2 * p1.x) + (p2.x - p0.x) * t + (2 * p0.x - 5 * p1.x + 4 * p2.x - p3.x) * t * t + (3 * p1.x - p0.x - 3 * p2.x + p3.x) * t * t * t)
			pr.y  = .5 * ( (2 * p1.y) + (p2.y - p0.y) * t + (2 * p0.y - 5 * p1.y + 4 * p2.y - p3.y) * t * t + (3 * p1.y - p0.y - 3 * p2.y + p3.y) * t * t * t)
			SetPoint(CurvedPath((ControlPointCount*50)+(t*50)),pr.x,pr.y)
		Next
		ControlPointCount = ControlPointCount + 1
	Loop
	CurvedPathPoints = (ControlPointCount-1)*50 + 50
	PathComplete=True
End Sub

