﻿Type=StaticCode
Version=2.52
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type PointType ( _
		x As Int, _
		y As Int)
	
	Type PeopleType ( _
		x As Int, _
		y As Int, _
		dx As Int, _
		dy As Int, _
		MaxV As Int, _
		lastx As Int, _
		lasty As Int, _
		HeadAngle As Int, _
		SizeR As Int, _
		IsMoving As Boolean, _
		IsSelected As Boolean, _
		CollisionChecked As Boolean, _
		FollowPath(200) As PointType, _
		PathCount As Int, _
		PathIsActive As Boolean, _
		PathIndex As Int)
	Dim Pp As PeopleType 
	
	' Diagonal Corners used to define box area
	Type BoxType ( _
		B0 As PointType, _
		B1 As PointType)
	
	
End Sub

Sub Generate(gWidth As Int, gHeight As Int)

	Pp.Initialize
	
	Pp.CollisionChecked = False
	Pp.dx = 1
	Pp.dy = 1
	Pp.HeadAngle = 0
	Pp.lastx = 0
	Pp.lasty = 0
	Pp.IsSelected= False
	Pp.SizeR = 10
	Pp.x= gWidth/2
	Pp.y= gHeight/2

End Sub



Sub UpdatePeople
	Dim RadAngle As Double 
	Dim Angle As Int
	
	' If pp.ismoving = true then
	If Pp.PathCount <> Pp.PathIndex Then
		' Find the angle and rotate to it
'		RadAngle = ATan((Pp.y - pp.FollowPath(Pp.PathIndex).y)/ _
'				     (Pp.x - pp.FollowPath(Pp.PathIndex).x) )
'		Angle = (180/3.14159) * (RadAngle+3.14159)
'		Angle = Angle + 180
'		If (Angle > 360) Then
'			Angle = Angle - 360
'		End If
'		If (Angle < 0 ) Then
'			Angle = Angle + 360
'		End If
		Dim P0 As PointType 
		P0.Initialize 
		P0.x = Pp.x 
		P0.y = Pp.y 
		Angle = CalcAngle(P0,Pp.FollowPath(Pp.PathIndex))
		Log("Head Angle:" & Pp.HeadAngle & " Angle:" & Angle)
		'Log("Head Angle:" + Pp.HeadAngle + " Angle:" + Angle)
		
		If Angle = Pp.HeadAngle Then
			' Move forward
'			If (Pp.x <> pp.followpath(Pp.PathIndex).x OR _
'				Pp.y <> pp.followpath(Pp.PathIndex).y) Then
'				'Pp.PathIndex = Pp.PathIndex + 1
'				Pp.dx = Cos(RadAngle)
'				Pp.dy = Sin(RadAngle)
'				Pp.x= Pp.x + Pp.dx 
'				Pp.y = Pp.y + Pp.dy 
'			Else
'				Pp.PathIndex = Pp.PathIndex + 1
'			End If
			Pp.x = Pp.FollowPath(Pp.PathIndex).x 
			Pp.y = Pp.FollowPath(Pp.PathIndex).y
			Pp.PathIndex = Pp.Pathindex + 1
		Else
			If Abs(Pp.HeadAngle - Angle) <= 10 Then
				Pp.HeadAngle = Angle
			Else
			
			
				If (Pp.HeadAngle - Angle) < 0 Then
					Pp.HeadAngle = Pp.HeadAngle + 10
				Else
					Pp.HeadAngle = Pp.HeadAngle - 10
				End If
				If Pp.HeadAngle > 360 Then
					Pp.HeadAngle = Pp.HeadAngle - 360
				End If
				If Pp.HeadAngle < 0 Then
					Pp.HeadAngle = Pp.HeadAngle + 360
				End If

			End If
		End If
		
	End If
End Sub

Sub SelectPeople(P As PointType)
	'Go Throuh all people
	'for i = o to pp.length-1
		If PointInBox(P,GenerateBox(Pp))=True Then
			Pp.IsSelected = True
			Pp.PathCount = 0
			Pp.PathIndex = 0
		End If
	'next
End Sub

Sub AssignPath(P() As PointType)
	'Go Throuh all people (for multiselect assign translated)
	'for i = o to pp.length-1
	If Pp.IsSelected = True Then
		' Use copy array
		Pp.FollowPath = P
		Pp.IsMoving = True
		Pp.IsSelected = False
		Pp.PathCount = 200
	End If
End Sub


Sub PointInBox(P As PointType,B As BoxType) As Boolean  'B0 and B1 are diagonal corners
	If (P.x > B.b0.x AND P.x < B.b1.x) AND (P.y > B.b0.y AND P.y < B.b1.y) Then
		Return True
	Else
		Return False
	End If

End Sub

Sub GenerateBox(P As PeopleType) As BoxType 
	Dim B As BoxType 
	B.Initialize 
	B.B0.x = P.x - P.SizeR 
	B.B0.y = P.y - P.SizeR 
	B.B1.x = P.x + P.SizeR 
	B.B1.y = P.y + P.SizeR 
	Return B
End Sub

Sub CalcAngle(P0 As PointType, P1 As PointType) As Int
    Dim a As Int
    
    If P0.x - P1.x = 0 Then
        a = 90
    Else
        a = ATanD((P0.y - P1.y)/(P0.x - P1.x))
    End If
    If P0.x - P1.x < 0 Then
        a = a + 180
    End If
	If a < 0 Then
		a  = a + 360
	End If
    Return a
End Sub